Option Strict On
Option Explicit On

Imports System

Public Class EnumDisplayCollection
   Inherits List(Of EnumDisplay)

   Public Shared Function CreateEnumDisplay(ByVal enumType As Type) As EnumDisplayCollection
      Return New EnumDisplayCollection(enumType)
   End Function

   Public Sub New(ByVal enumType As Type)

      Dim values As System.Array = [Enum].GetValues(enumType)
      For Each value As Int32 In values
         Me.Add(New EnumDisplay(value, enumType))
      Next
   End Sub

End Class

Public Class EnumDisplay
   Private mValue As Int32
   Private mImageSource As String
   Private mText As String
   Private mDescription As String

   Public Sub New(ByVal value As Int32, ByVal enumType As Type)
      mValue = value
      mText = [Enum].GetName(enumType, value)
      mImageSource = "Images\" & Text & ".gif"
      Dim descResourceName As String = enumType.Name & Text & "Description"
      mDescription = My.Resources.ResourceManager.GetString(descResourceName)
   End Sub

   Public Sub New(ByVal value As Int32, _
            ByVal imageSource As String, _
            ByVal text As String, _
            ByVal description As String)
      Me.mValue = value
      Me.mImageSource = imageSource
      Me.mText = text
      Me.mDescription = description
   End Sub

   Public Property Value() As Int32
      Get
         Return mValue
      End Get
      Set(ByVal value As Int32)
         mValue = value
      End Set
   End Property


   Public Property ImageSource() As String
      Get
         Return Me.mImageSource
      End Get
      Set(ByVal value As String)
         Me.mImageSource = value
      End Set
   End Property

   Public Property Text() As String
      Get
         Return Me.mText
      End Get
      Set(ByVal value As String)
         Me.mText = value
      End Set
   End Property

   Public Property Description() As String
      Get
         Return Me.mDescription
      End Get
      Set(ByVal value As String)
         Me.mDescription = value
      End Set
   End Property
End Class
