Option Strict On
Option Explicit On

Imports KadGen
Imports System

' Interaction logic for Customer2.xaml
Partial Public Class Customer2
   Inherits System.Windows.Controls.UserControl

   Dim mCustomers As BObjects.CustomerCollection
   Dim mGenderDisplay As BObjects.EnumDisplayCollection

   Public Sub New()
      InitializeComponent()

      Me.DataContext = SharedData.Customers

      mGenderDisplay = BObjects.EnumDisplayCollection.CreateEnumDisplay( _
         GetType(BObjects.Gender))
      GenderComboBox.ItemsSource = mGenderDisplay

   End Sub

   Private Sub HelpButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
      MessageBox.Show("I don't have any help today")
   End Sub

   Private Sub SaveCanExecute( _
            ByVal sender As Object, _
            ByVal e As CanExecuteRoutedEventArgs)
      If mCustomers Is Nothing Then
         e.CanExecute = False
      Else
         e.CanExecute = Not mCustomers.HasErrors
      End If
   End Sub

   Private Sub SaveExecuted( _
            ByVal sender As Object, _
            ByVal e As ExecutedRoutedEventArgs)
      MessageBox.Show("Save")
   End Sub

   Private Sub Clerical_Click( _
            ByVal sender As Object, _
            ByVal e As RoutedEventArgs)
      Dim principal As Security.Principal.IPrincipal = New BObjects.UserPrincipal("Clerical User")
      System.Threading.Thread.CurrentPrincipal = principal
      Me.AuthorizationDecorator.Authorize()
   End Sub

   Private Sub Manager_Click( _
            ByVal sender As Object, _
            ByVal e As RoutedEventArgs)
      Dim principal As Security.Principal.IPrincipal = New BObjects.UserPrincipal("Manager User")
      System.Threading.Thread.CurrentPrincipal = principal
      Me.AuthorizationDecorator.Authorize()
   End Sub

End Class
